
import * as $calcit from "./calcit.core.mjs";
import { _LT__GT_ } from "./respo.core.mjs";
import { _$e__LT_ } from "./respo.comp.space.mjs";
import { a } from "./respo.core.mjs";
import { addresses } from "../entry/address.mjs";
import { body } from "./respo.core.mjs";
import chalk from "chalk";
import { create_element } from "./respo.core.mjs";
import dayjs from "dayjs";
import { div } from "./respo.core.mjs";
import finalhandler from "finalhandler";
import formidable from "formidable";
import * as $fs from "fs";
import { head } from "./respo.core.mjs";
import { hsl } from "./respo-ui.core.mjs";
import { html } from "./respo.core.mjs";
import latest_version from "latest-version";
import { link } from "./respo.core.mjs";
import { list__GT_ } from "./respo.core.mjs";
import { make_string } from "./respo.render.html.mjs";
import * as $path from "path";
import prettysize from "prettysize";
import qrcode from "qrcode-terminal";
import * as $respo_ui_DOT_core from "./respo-ui.core.mjs";
import serve_static from "serve-static";
import * as $skir_DOT_core from "./skir.core.mjs";
import url from "url";
var _kwd={};
["after-start","body","charset","code","color","content","created-time","effect","ellipsis","font-family","font-size","font-weight","headers","hidden","href","inner-text","line-height","max-width","message","meta","name","none","original-request","overflow","padding","port","rel","size","small","style","text-decoration","text-overflow",].forEach(x => {
  _kwd[x] = $calcit.kwd(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export async function check_version_$x_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('check-version!', 0, arguments.length);
let pkg = JSON.parse($fs.readFileSync($path.join(dirname, "../package.json")));
let version = pkg.version;
let npm_version = (await latest_version(pkg.name));

if ($calcit._$e_(npm_version, version)) { console.log($calcit.printable("Running latest version", version)) }else { console.log($calcit.printable(chalk.yellow($calcit.str("New version ", npm_version, " available, current one is ", version, " . Please upgrade!", "\n\nyarn global add file-sucker\n")))) }

}
export async function load_stats_$x_(xs) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('load-stats!', 1, arguments.length);
let tasks = $calcit.js_array();
$calcit.foldl(xs, null, function doseq_fn_PCT_(_acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);
return tasks.push(new Promise(function f_PCT_(resolve, reject) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return $fs.stat(x, function f_PCT_(err, stat) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return resolve($calcit._$n__$M_(_kwd["name"], x, _kwd["size"], stat.size, _kwd["created-time"], stat.ctime))
}
)
}
))
}
);
return Promise.all(tasks)

}
export function on_download_$x_(req, res) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('on-download!', 2, arguments.length);
req.url = $calcit.invoke_method("replace",req.url,"/files/", "/");
console.log($calcit.printable("url", req.url));
serve_files_$x_(req, res, finalhandler(req, res));
return _kwd["effect"]
}
export function turn_list(arr) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('turn-list', 1, arguments.length);
return function f_PCT_(xs, as) {
  
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
  
  let times_AUTO_3 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_2 = null;
    if (times_AUTO_3 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if ($calcit._$e_(0, as.length)) { ret_AUTO_2 =xs }else { ret_AUTO_2 =$calcit.recur($calcit.conj(xs, as["0"]), as.slice(1)) }

    if (ret_AUTO_2 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_2.args.length !== 2) throw _calcit_args_mismatch('f%', 2, ret_AUTO_2.args.length);
      [ xs, as ] = ret_AUTO_2.args;
      
      times_AUTO_3 += 1;
      continue;
    } else {
      return ret_AUTO_2;
    }
  }
}

($calcit._$L_(), arr)
}
export async function on_file_indexed_$x_(req, res) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('on-file-indexed!', 2, arguments.length);
let filenames = $calcit.filter($calcit.to_calcit_data($fs.readdirSync(".")), function f_PCT_(filename) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.invoke_method("isFile",$fs.lstatSync(filename),)
}
);
let files_info = (await load_stats_$x_(filenames));
let result = make_string(html($calcit._$n__$M_(), head($calcit._$n__$M_(), create_element(_kwd["meta"], $calcit._$n__$M_(_kwd["content"], "width=device-width, initial-scale=1, maximum-scale=1.0, user-scalable=no", _kwd["name"], "viewport")), create_element(_kwd["meta"], $calcit._$n__$M_(_kwd["charset"], "utf8")), link($calcit._$n__$M_(_kwd["rel"], "stylesheet", _kwd["href"], "http://cdn.tiye.me/favored-fonts/josefin-sans.css"))), body($calcit._$n__$M_(), div($calcit._$n__$M_(), ( $calcit.empty_$q_(filenames) ? div($calcit._$n__$M_(_kwd["style"], $calcit.merge($respo_ui_DOT_core.center, $calcit._$n__$M_(_kwd["padding"], 80))), _LT__GT_("No files", $calcit._$n__$M_(_kwd["font-family"], $respo_ui_DOT_core.font_fancy, _kwd["color"], hsl(0, 0, 80), _kwd["font-size"], 40, _kwd["font-weight"], 300))) : null ), list__GT_($calcit._$n__$M_(_kwd["style"], $calcit._$n__$M_(_kwd["padding"], "24px 8px")), $calcit.map_indexed($calcit.invoke_method("sort-by",turn_list(files_info),function f_PCT_(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.negate($calcit.get(x, _kwd["created-time"]))
}
), function f_PCT_(idx, file) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return $calcit._$L_(idx, div($calcit._$n__$M_(_kwd["style"], $calcit.merge($respo_ui_DOT_core.row, $calcit._$n__$M_(_kwd["line-height"], "40px"))), a($calcit._$n__$M_(_kwd["href"], $calcit.str("/files/", $calcit.get(file, _kwd["name"])), _kwd["inner-text"], $calcit.get(file, _kwd["name"]), _kwd["style"], $calcit._$n__$M_(_kwd["text-decoration"], _kwd["none"], _kwd["font-family"], $respo_ui_DOT_core.font_fancy, _kwd["font-size"], 16, _kwd["max-width"], "50vw", _kwd["overflow"], _kwd["hidden"], _kwd["text-overflow"], _kwd["ellipsis"]))), _$e__LT_(16, null), _LT__GT_(prettysize($calcit.get(file, _kwd["size"])), $calcit._$n__$M_(_kwd["font-family"], $respo_ui_DOT_core.font_fancy, _kwd["color"], hsl(0, 0, 70), _kwd["font-size"], 12)), _$e__LT_(16, null), _LT__GT_($calcit.invoke_method("format",dayjs($calcit.get(file, _kwd["created-time"])),"MM-DD HH:mm"), $calcit._$n__$M_(_kwd["font-family"], $respo_ui_DOT_core.font_fancy, _kwd["color"], hsl(0, 0, 70), _kwd["font-size"], 12))))
}
))))));
return $calcit._$n__$M_(_kwd["code"], 200, _kwd["headers"], $calcit._$n__$M_("Content-Type", "text/html"), _kwd["body"], result)

}
export function on_page_$x_(req, res) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('on-page!', 2, arguments.length);
serve(req, res, finalhandler(req, res));
return _kwd["effect"]
}
export function on_upload_$x_(req, res) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('on-upload!', 2, arguments.length);
(function __fn__(){
let origin = req.headers.origin;

if ($calcit.some_$q_(origin)) { return res.setHeader("Access-Control-Allow-Origin", origin) }else { return null }

})();
res.setHeader("Access-Control-Allow-Methods", "POST,GET,OPTIONS");
let v__1 = req.method;

if ($calcit._$n__$e_(v__1, "POST")) { return function f_PCT_(send_$x_) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
let form = new formidable.IncomingForm();
let size_limit = $calcit._$s_(4, 1024, 1024, 1024);
console.log($calcit.printable("New request of file transferring..."));
form.maxFieldsSize = size_limit;
form.maxFileSize = size_limit;
return form.parse(req, function f_PCT_(error, fields, files) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('f%', 3, arguments.length);
( $calcit.some_$q_(error) ? (function __fn__(){
let err_AUTO_4 = new Error(error);
 err_AUTO_4.data = null;
 throw err_AUTO_4;
})() : null );
let file = files.file;
console.log($calcit.printable("Received file:", file.originalFilename));
return $fs.rename(file.filepath, $path.join(process.env.PWD, file.originalFilename), function f_PCT_(rename_error) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
( $calcit.some_$q_(rename_error) ? (function __fn__(){
let err_AUTO_5 = new Error(rename_error);
 err_AUTO_5.data = null;
 throw err_AUTO_5;
})() : null );
return send_$x_($calcit._$n__$M_(_kwd["code"], 200, _kwd["headers"], $calcit._$n__$M_(), _kwd["message"], "Uploaded"))
}
)

}
)

}
 }
 else if ($calcit._$n__$e_(v__1, "GET")) { return $calcit._$n__$M_(_kwd["code"], 200, _kwd["body"], "use POST") }
 else if ($calcit._$n__$e_(v__1, "OPTIONS")) { return $calcit._$n__$M_(_kwd["code"], 200, _kwd["body"], "ok") }else { return $calcit._$n__$M_(_kwd["code"], 404, _kwd["body"], "method not supported") }

}
export function on_request_$x_(req_edn, res) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('on-request!', 2, arguments.length);
let req = $calcit.get(req_edn, _kwd["original-request"]);

if ($calcit._$e_("/upload", req.url)) { return on_upload_$x_(req, res) }
 else if ((function __fn__(){
let v1__2 = $calcit._$e_(req.url, "/files");

if ($calcit.nil_$q_(v1__2)) { return $calcit._$e_(req.url, "/files/") }
 else if ($calcit._$e_(false, v1__2)) { return $calcit._$e_(req.url, "/files/") }else { return v1__2 }

})()) { return on_file_indexed_$x_(req, res) }
 else if ($calcit.invoke_method("starts-with?",req.url,"/files/")) { return on_download_$x_(req, res) }else { return on_page_$x_(req, res) }

}
export function main_$x_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('main!', 0, arguments.length);
let port = (function __fn__(){

if ($calcit.nil_$q_(process.env.PORT)) { 
if ($calcit.nil_$q_(process.env.port)) { return 4000 }
 else if ($calcit._$e_(false, process.env.port)) { return 4000 }else { return process.env.port } }
 else if ($calcit._$e_(false, process.env.PORT)) { 
if ($calcit.nil_$q_(process.env.port)) { return 4000 }
 else if ($calcit._$e_(false, process.env.port)) { return 4000 }else { return process.env.port } }else { return process.env.PORT }
})();
return $skir_DOT_core.create_server_$x_(function _PCT__BSL_(_PCT_, _PCT_2) { 
if (arguments.length < 0) throw new Error('too few arguments');
if (arguments.length > 2) throw new Error('too many arguments');
return on_request_$x_(_PCT_, _PCT_2)
}
, $calcit._$n__$M_(_kwd["port"], port, _kwd["after-start"], function f_PCT_(options) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return addresses.forEach(function f_PCT_(ip_address, _idx, _a) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('f%', 3, arguments.length);
let address = $calcit.str("\n", "http://", ip_address, ":", port, "\n");
console.log($calcit.printable("Open page on your phone and send file:", "\n", address));
qrcode.generate(address, $calcit._$n_js_object(_kwd["small"], true), console.log);

if ($calcit.not_$e_(process.env.NO_VERSION_CHECK, "false")) { return check_version_$x_() }else { console.log($calcit.printable("[INFO] skipped version checking.")) }

}
)
}
))

}
export function reload_$x_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('reload!', 0, arguments.length);
console.log($calcit.printable("reloaded!"))
}



export var dirname = $path.dirname(url.fileURLToPath(new URL("", import.meta.url)));

export var serve_files_$x_ = serve_static(process.env.PWD, $calcit._$n_js_object("index", $calcit.js_array()));

export var serve = serve_static($path.join(dirname, "../dist"), $calcit._$n_js_object("index", $calcit.js_array("index.html")));

