
import * as $calcit from "./calcit.core.mjs";
var _kwd={};
["align-items","display","flex-direction","justify-content",].forEach(x => {
  _kwd[x] = $calcit.kwd(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function hsl(h, s, l, a) { 
if (arguments.length < 3) throw new Error('too few arguments');
if (arguments.length > 4) throw new Error('too many arguments');

if ($calcit.some_$q_(a)) { return $calcit.str("hsl(", h, ",", s, "%,", l, "%,", a, ")") }else { return $calcit.str("hsl(", h, ",", s, "%,", l, "%)") }
}



export var center = $calcit._$n__$M_(_kwd["display"], "flex", _kwd["flex-direction"], "column", _kwd["justify-content"], "center", _kwd["align-items"], "center");

export var font_fancy = "Josefin Sans, Helvetica neue, Arial, sans-serif";

export var row = $calcit._$n__$M_(_kwd["display"], "flex", _kwd["align-items"], "stretch", _kwd["flex-direction"], "row");

