
import * as $calcit from "./calcit.core.mjs";
import * as $respo_DOT_schema from "./respo.schema.mjs";
var _kwd={};
[].forEach(x => {
  _kwd[x] = $calcit.kwd(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function component_$q_(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('component?', 1, arguments.length);

if ($calcit.record_$q_(x)) { return $calcit._$n_record_$o_matches_$q_($respo_DOT_schema.Component, x) }else { return false }
}
export function effect_$q_(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('effect?', 1, arguments.length);

if ($calcit.record_$q_(x)) { let v1__1 = $calcit._$n_record_$o_matches_$q_($respo_DOT_schema.Effect, x);

if (v1__1) { return v1__1 }else { return false }
 }else { return false }
}
export function element_$q_(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('element?', 1, arguments.length);

if ($calcit.record_$q_(x)) { return $calcit._$n_record_$o_matches_$q_($respo_DOT_schema.Element, x) }else { return false }
}



