
import * as $calcit from "./calcit.core.mjs";
import { any_ADD_ } from "./lilac.core.mjs";
import { bool_ADD_ } from "./lilac.core.mjs";
import { dev_$q_ } from "./lilac.core.mjs";
import { dict_ADD_ } from "./lilac.core.mjs";
import * as $http from "node:http";
import { key__GT_str } from "./skir.util.mjs";
import { keyword_ADD_ } from "./lilac.core.mjs";
import { nil_ADD_ } from "./lilac.core.mjs";
import { number_ADD_ } from "./lilac.core.mjs";
import { optional_ADD_ } from "./lilac.core.mjs";
import { or_ADD_ } from "./lilac.core.mjs";
import { promise_$q_ } from "./skir.util.mjs";
import * as $querystring from "node:querystring";
import { record_ADD_ } from "./lilac.core.mjs";
import { string_ADD_ } from "./lilac.core.mjs";
import { validate_lilac } from "./lilac.core.mjs";
var _kwd={};
["after-start","body","check-keys?","code","connect","delete","effect","formatted-message","get","head","headers","host","message","method","ok?","options","original-request","patch","port","post","put","query","trace","url",].forEach(x => {
  _kwd[x] = $calcit.kwd(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function req__GT_edn(req) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('req->edn', 1, arguments.length);
return $calcit._$n__$M_(_kwd["method"], (function __fn__(){
let v__1 = req.method;

if ($calcit._$n__$e_(v__1, "GET")) { return _kwd["get"] }
 else if ($calcit._$n__$e_(v__1, "HEAD")) { return _kwd["head"] }
 else if ($calcit._$n__$e_(v__1, "POST")) { return _kwd["post"] }
 else if ($calcit._$n__$e_(v__1, "PUT")) { return _kwd["put"] }
 else if ($calcit._$n__$e_(v__1, "DELETE")) { return _kwd["delete"] }
 else if ($calcit._$n__$e_(v__1, "CONNECT")) { return _kwd["connect"] }
 else if ($calcit._$n__$e_(v__1, "OPTIONS")) { return _kwd["options"] }
 else if ($calcit._$n__$e_(v__1, "TRACE")) { return _kwd["trace"] }
 else if ($calcit._$n__$e_(v__1, "PATCH")) { return _kwd["patch"] }else { return req.method }

})(), _kwd["url"], req.url, _kwd["query"], $calcit.to_calcit_data($querystring.parse((function __fn__(){
let v1__2 = $calcit.aget(req.url.split("?"), 1);

if ($calcit.nil_$q_(v1__2)) { return "" }
 else if ($calcit._$e_(false, v1__2)) { return "" }else { return v1__2 }

})())), _kwd["headers"], $calcit.to_calcit_data(req.headers), _kwd["body"], null, _kwd["original-request"], req)
}
export function write_response_$x_(res, edn_res) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('write-response!', 2, arguments.length);
( dev_$q_ ? (function __fn__(){
let result__3 = validate_lilac(edn_res, lilac_response);

if ($calcit.not($calcit.get(result__3, _kwd["ok?"]))) { console.log($calcit.printable($calcit.get(result__3, _kwd["formatted-message"]), "\n", $calcit.str("(dev-check ", new $calcit.CalcitSymbol("edn-res"), " ", new $calcit.CalcitSymbol("lilac-response"), "), where props is: ", edn_res))) }else { return  null; }

})() : null );
res.statusCode = (function __fn__(){
let v1__4 = $calcit.get(edn_res, _kwd["code"]);

if ($calcit.nil_$q_(v1__4)) { return 200 }else { return v1__4 }

})();
res.statusMessage = (function __fn__(){
let v1__5 = $calcit.get(edn_res, _kwd["message"]);

if ($calcit.nil_$q_(v1__5)) { return "OK" }else { return v1__5 }

})();
$calcit.foldl((function __fn__(){
let v1__6 = $calcit.get(edn_res, _kwd["headers"]);

if ($calcit.nil_$q_(v1__6)) { return $calcit._$n__$M_() }else { return v1__6 }

})(), null, function doseq_fn_PCT_(_acc, pair) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);
let k = $calcit._$n_list_$o_nth(pair, 0);
let v = $calcit._$n_list_$o_nth(pair, 1);
return res.setHeader(key__GT_str(k), key__GT_str(v))

}
);
return res.end((function __fn__(){
let body = $calcit.get(edn_res, _kwd["body"]);

if ($calcit.list_$q_(body)) { return $calcit.format_cirru_edn(body) }
 else if ($calcit.map_$q_(body)) { return $calcit.format_cirru_edn(body) }
 else if ($calcit.nil_$q_(body)) { return "" }
 else if ($calcit.string_$q_(body)) { return body }
 else if ($calcit.keyword_$q_(body)) { return $calcit.pr_str(body) }
 else if (Array.isArray(body)) { return JSON.stringify(body) }else { return JSON.stringify(body) }

})())
}
export function handle_request_$x_(req, res, handler) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('handle-request!', 3, arguments.length);
try {
  let edn_req = req__GT_edn(req);
let response = handler(edn_req, res);

if ($calcit.map_$q_(response)) { return write_response_$x_(res, response) }
 else if ($calcit.fn_$q_(response)) { return response(function f_PCT_(response_data) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return write_response_$x_(res, response_data)
}
) }
 else if (promise_$q_(response)) { return response.then(function f_PCT_(result) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return write_response_$x_(res, result)
}
) }
 else if ($calcit._$e_(response, _kwd["effect"])) { return null }else { console.log($calcit.printable("Response:", response));
let err_AUTO_1 = new Error("Unknown response!");
 err_AUTO_1.data = null;
 throw err_AUTO_1;
 }

} catch (errMsg_AUTO_2) {
  return  (function f_PCT_(err) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
console.error(err);
res.statusCode = 500;
res.statusMessage = "Server Error";
return res.end($calcit.str(err.toString(), "\n", "\n", err.stack))

}
)(errMsg_AUTO_2)
}
}
export function create_server_$x_(handler, user_options) { 
if (arguments.length < 1) throw new Error('too few arguments');
if (arguments.length > 2) throw new Error('too many arguments');
$calcit.reset_$x_(_$s_req_handler, handler);
let options = $calcit.merge(default_options, user_options);
let server = $http.createServer(function f_PCT_(req, res) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return handle_request_$x_(req, res, $calcit.deref(_$s_req_handler))
}
);
return server.listen($calcit.get(options, _kwd["port"]), $calcit.get(options, _kwd["host"]), function f_PCT_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('f%', 0, arguments.length);
return $calcit.get(options, _kwd["after-start"])(options)
}
)

}



export var _$s_req_handler = 
($calcit.peekDefatom("skir.core/*req-handler") ?? $calcit.defatom("skir.core/*req-handler", null))
;

export var default_options = $calcit._$n__$M_(_kwd["port"], 4000, _kwd["after-start"], function f_PCT_(options) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
console.log($calcit.printable($calcit.str("Server listening on ", $calcit.get(options, _kwd["port"]))))
}
, _kwd["host"], "0.0.0.0");

export var lilac_response = record_ADD_($calcit._$n__$M_(_kwd["code"], number_ADD_(), _kwd["message"], optional_ADD_(string_ADD_()), _kwd["headers"], optional_ADD_(dict_ADD_(or_ADD_($calcit._$L_(keyword_ADD_(), string_ADD_())), or_ADD_($calcit._$L_(keyword_ADD_(), string_ADD_(), bool_ADD_(), nil_ADD_())))), _kwd["body"], any_ADD_()), $calcit._$n__$M_(_kwd["check-keys?"], true));

